(defun c:fonted03()

; FontEditor zur Erzeugung von AutoCAD UNICODE-SHP-Dateien
(setq pnam "FontEditor")	;Programmname
(setq pver " Version 4.0 ")	;Programmversion
(setq cpry " (c) Rust 1990-2003")
(princ (strcat "\n" pnam pver cpry))

(setq *olderror* *error*)	;Fehlerhandler retten

(defun *error*(msg)	;Fehlerhandler
(res_sysvars)	;restore sysvars
(setq *error* *olderror*)	;restore Fehlerhandler
(princ pnam)
(princ pver)
(princ cpry)
(princ))	;end defun *error*



(defun get_sysvars()	;Systemvariablen merken
(setq o_s (getvar "osmode"))	;Objektfang merken
(setq s_m (getvar "snapmode"))	;Fang merken
(setq a_p (getvar "aperture"))	;Aperture merken
(setq c_e (getvar "cmdecho"))	;Echo merken
(setq b_m (getvar "blipmode"))	;Blips merken
(setq p_w (getvar "plinewid"))	;Polylinienbreite
(setq c_c (getvar "cecolor"))	;Farbe
(setq c_l (getvar "celtype"))	;Linientyp
)	;end defun get_sysvars

(defun res_sysvars()	;restore sysvars
(setvar "osmode" o_s)	;Objektfang
(setvar "snapmode" s_m)	;Fang
(setvar "aperture" a_p)	;Aperture 
(setvar "cmdecho" c_e)	;Echo
(setvar "blipmode" b_m)	;Blips
(setvar "plinewid" p_w)	;Polylinienbreite
(setvar "cecolor" c_c)	;Farbe
(setvar "celtype" c_l)	;Linientyp
)	;end defun res_sysvars

(get_sysvars)	;Systemvariablen merken


(setvar "cmdecho" 0)	;Echo aus
(setvar "blipmode" 0)	;keine Blips












(defun *error*(msg)(princ msg)(princ))


(defun varse()	;Variable setzen
(setq eli nil)	;Elementeliste
(setq lianz 0)	;Linienanzahl
(setq lianf nil)	;Anfang Linie
(setq liend nil)	;Ende Linie
(setq blanz 0)	;Blockanzahl
(setq txanz 0)	;Anzahl Texte
(setq kom nil)	;Kommentar
(setq synum nil)	;Symbol-/ASCII-Nr.
(setq dnam nil)	;Dateiname
(setq xys nil)	;xy-Startpunkt (x . y)
(setq xyh nil)	;Hhe=Oberlnge (x . y)
(setq xyu nil)	;Unterlnge
(setq xye nil)	;Endpunkt

(setq boanz 0)	;Bogenanzahl
(setq bomix nil)	;Bogenmittelpunkt x
(setq bomiy nil)	;Bogenmittelpunkt y
(setq boanf nil)	;Bogen Anfang
(setq boend nil)	;Bogen Ende
(setq borad nil)	;Bogenradius
(setq bowi nil)	;Bogen Winkel
(setq boflag t)	;Bogen <=180 Grad

)	;Ende defun varse


(defun holasa()	;Auswahlsatz holen
(menucmd "S=BLOCK 3")	;Menueumschaltung


(setq asa (ssget))	;Auswahlanfrage
(if (= asa nil)(print "Kein Element gewhlt ") 	;Fehler
(progn	;sonst Beginn
(setq lasa (sslength asa))	;Auswahlsatz
(menucmd "S=S")))	;Hauptmenue
) 	;Ende defun holasa


(defun holspkt( / temp)	;Startpunkt holen
(setq temp lasa)	;Lnge merken
 (while (> temp 0)	;solange Elemente
   (setq temp (1- temp))	;decr. Lnge
   (setq eli (entget (ssname asa temp)))	;Elementlisten
   (if (= (cdr (assoc '2 eli)) "SPKT")	;wenn Startpunkt
   (progn	;Beginn
   (setq temp 0)	;spkt gefunden
   (setq xys (cdr (assoc '10 eli)))	;xy lesen
   (setq xys (cons (atoi (rtos (car xys) 2 0)) 	;runden x
             (atoi (rtos (nth 1 xys) 2 0)) ))	;runden y
 )))	;end progn/if/while
)	;Ende defun holspkt


(defun holel( / temp)	;Elemente holen
(setq temp lasa)	;Lnge merken
  (while (> temp 0)	;solange Elemente
    (setq temp (1- temp))	;decr. Lnge
    (setq eli (entget (ssname asa temp)))	;Elementlisten
    (setq etyp (cdr (assoc '0 eli)))	;Elementtyp
    (if (= etyp "LINE") (holli))	;Element ist Linie
    (if (= etyp "INSERT") (holblk))	;Element ist Block
    (if (= etyp "TEXT") (holtxt))	;Element ist Text
    (if (= etyp "ARC") (holbo))	;Element ist Bogen
  )	;Ende while temp>0
)	;Ende defun holel


(defun holli()	;hole xy-Koordinaten
(setq lianz (1+ lianz))	;Anzahl inkr.
(setq lianf (cons (rusu 	;hinzufuegen/runden
            (cdr (assoc '10 eli))) lianf))	;xy-Anfang
(setq liend (cons (rusu 	;hinzufuegen/runden
            (cdr (assoc '11 eli))) liend))	;xy-Ende
)	;Ende defun holli


(defun holblk()	;hole Einfuegepunkt
(setq blanz (1+ blanz))	;Blockanzahl inkr.
  (if (= (cdr (assoc '2 eli)) "EPKT")	;wenn Endpunkt
    (setq xye (rusu (cdr (assoc '10 eli)))))	;xy lesen/runden
  (if (= (cdr (assoc '2 eli)) "HPKT")	;wenn Hochpunkt
    (setq xyh (rusu (cdr (assoc '10 eli)))))	;xy lesen/runden
  (if (= (cdr (assoc '2 eli)) "UPKT")	;wenn Unterpunkt
    (setq xyu (rusu (cdr (assoc '10 eli)))))	;xy lesen/runden
)	;Ende defun holblk


(defun holtxt( / temp z istd)	;hole Text
(setq temp (cdr (assoc '1 eli)))	;Text merken
(setq txanz (1+ txanz))	;Anzahl inkr.
(if (< (ascii temp) 58) 	;1. Zeichen
  (if (> (ascii temp) 47) (setq synum temp))	;ist  Zahl
  (progn	;sonst String
  (setq istd nil)	;kein Dateiname
  (setq z (strlen temp))	;Stringlnge
    (while (> z 0)	;Durchsuchen
      (if (= (ascii (substr temp z 1)) 46)	;wenn Punkt: Datei
      (progn	;Beginn
      (setq dnam temp)	;Dateiname
      (setq istd T)))	;gefunden/end if
    (setq z (1- z)))	;end while z>0
    (if (= istd nil) (setq kom (strcase temp t)))	;Kommentar  
) )	;end if/progn
)	;Ende defun holtxt

(defun holbo()	;hole Bogen
 (setq boanz (1+ boanz))	;Anzahl inkr.
 
 (setq mpkt (cdr (assoc '10 eli)))	;Mittelpunkt
 (setq xmi (nth 0 mpkt))	;x-Koordinate
 (setq ymi (nth 1 mpkt))	;y-Koordinate
 (setq xmi (- xmi (car xys)))	;x-Ko. relativ
 (setq ymi (- ymi (cdr xys)))	;y-Ko. relativ
 (setq bomix (cons xmi bomix))	;dazu
 (setq bomiy (cons ymi bomiy))	;dazu
 
 
 (setq fi1 (cdr (assoc '50 eli)))	;Startwinkel
 (setq fi2 (cdr (assoc '51 eli)))	;Endwinkel
 (setq ra1 (cdr (assoc '40 eli)))	;Radius
 
 (setq boanf (cons fi1 boanf))	;hinzu
 (setq boend (cons fi2 boend))	;hinzu
 (setq borad (cons ra1 borad))	;hinzu
             
 (setq fimax (- fi2 fi1))	;Bogenwinkel
 (if (< fimax 0)(setq fimax (+ (* 2 pi) fimax)))
 (if (> fimax pi)(setq boflag nil))	;Fehler
)	;end defun holbo




(defun rusu(xy)	;Runden/Subtr
(cons (- (atoi (rtos (car xy) 2 0)) (car xys))	;x
   (- (atoi (rtos (nth 1 xy) 2 0)) (cdr xys)))	;y
)	;Ende defun rusu


(defun verti1()	;vertikal1
(setq zab (itoa (+ (cdr xyh) 9) ))	;= Oberl. + 9
(setq bab (itoa (/ (car xye) 2) ))	;chr Abstand/2
)	;Ende defun zeiab


(defun maz1(pass / temp)	;mache Zeile 1
(setq temp (strcat "*0" synum "," (itoa byts)))	;z.B. *,65,58
(if (/= kom nil)	;Konnentar
 (setq temp (strcat temp "," (strcase kom t))))	;z.B. *,65,58,uca
(write-line temp)	;Anzeigen
(if (= pass 2)(write-line temp dch))	;nach dch
)	;Ende defun maz1


(defun maz2(pass / temp dx dy)	;mache Zeile 2
(setq dx (- 0 (/ (car xye) 2)))	;-halbe Breite
(setq dy (- 0 (cdr xyh)))	;-Hoehe
(setq temp (strcat "2,14,8," (itoa dx)	;Vertikalstil
              "," (itoa dy) ",14,5,"))	;dx,dy,push
(setq byts (+ byts 7))	;7 Bytes merken
(if (= pass 2)(write-line temp dch))	;nach dch
)	;Ende defun maz2


(defun maz3(pass / temp dx dy)	;mache Zeile 3
(setq lianf (reverse (cons xye lianf)))	;Endpunkt dazu
(setq liend (reverse liend))	;auch umdrehen
(setq dx (car(nth 0 lianf)))	;delta x
(setq dy (cdr(nth 0 lianf)))	;delta y
(setq temp (strcat "2" "," "8" "," 	;pen up, rel xy
           (itoa dx) "," (itoa dy) ","))	;delta x, y
(setq byts (+ byts 4))	;Bytes merken
(if (= pass 2)(write-line temp dch))	;nach dch
)	;Ende defun maz3


(defun mazn(pass / temp dx dy z z1 pen)	;mache N Zeilen 
(setq z 0)	;Zhler=0
(setq pen "up")	;Feder oben
(setq temp "")	;reset temp
(while (< z  lianz)	;solange Linien
  (setq z1 (1+ z))	;z1=z+1
  (setq dx (- (car(nth z liend))	;Linienende
              (car(nth z lianf))))	;-Anfang
  (setq dy (- (cdr(nth z liend))	;Linienende
              (cdr(nth z lianf))))	;-Anfang
  (if (= pen "up")	;wenn pen up
  (progn	;dann Beginn
  (setq temp (strcat temp " 1,8,"	;"1" und rel
             (itoa dx) "," (itoa dy) ","))	;xy
  (setq byts (+ byts 4))	;4 Bytes merken
  (setq pen "down")	;down
  )	;end progn
  (progn	;sonst
  (setq temp (strcat temp " 8,"	;keine "1"
             (itoa dx) "," (itoa dy) ","))	;xy rel
  (setq byts (+ byts 3)))	;3 Bytes merken
  )	;end if pen=up
  (if (> (strlen temp) 45)	;Zeilenlnge>45
  (progn	;dann Beginn
   (if (= pass 2)(write-line temp dch))	;nach dch
   (setq temp "")	;reset temp
  ))	;end if/progn
  (setq dx (- (car(nth z1 lianf))	;nchster Anf.
              (car(nth z liend))))	;-aktuelles Ende
  (setq dy (- (cdr(nth z1 lianf))	;nchster Anf.
              (cdr(nth z liend))))	;-aktuelles Ende
  (if (> (+ (abs dx) (abs dy)) 0)	;if keine Luecke
    (progn	;dann Beginn
    (setq temp (strcat temp " 2,8,"	;pen up rel
             (itoa dx) "," (itoa dy)  ","))	;xy 
    (setq pen "up")	;pen ist up
    (setq byts (+ byts 4))	;Bytes merken
  ))	;end progn/if
  (setq z (1+ z))	;inkr z
)	;Ende while
(if (and (= pass 2) (/= temp "") )
    (write-line temp dch))	;rest speichern
)	;Ende defun mazn





(defun mabo(pass)	;mache Bgen

(setq temp (strcat " 2,8,"	;Feder hoch
                   (itoa (- 0 (car xye))) ","	;zum Startpunkt
                   (itoa (- 0 (cdr xye))) ","	;zum Startpunkt
                   ))	;zurck
(setq byts (+ byts 4))	;4 dazu                   
(if (= pass 2)(write-line temp dch))	;nach dch

 (setq z 0)	;Zhler 0
 (while (< z boanz)	;alle Bgen
  (setq bmx (nth z bomix))	;Mittelpunkt x
  (setq bmy (nth z bomiy))	;Mittelpunkt y
  (setq swi (nth z boanf))	;Startwinkel
  (setq ewi (nth z boend))	;Endwinkel
  (setq bra (nth z borad))	;Radius
  (setq spb (polar (list bmx bmy 0) swi bra))	;Startpunkt Bogen
  (setq epb (polar (list bmx bmy 0) ewi bra))	;Endpunkt Bogen
  (setq seb (distance epb spb))	;Sehnenlnge
  (setq fi (- ewi swi))	;Bogenwinkel
  (if (< fi 0.0)(setq fi (- (* 2.0 pi) fi)))	;Bogen geht ber 0
  (setq abb (* bra (- 1.0 (cos (/ fi 2.0)))))	;Ausbuchtung Bogen
  (setq abb (fix (+ 0.5 (* 254 (/ abb seb)))))	;Ausbuchtung relativ
  (setq temp (strcat "8,"	;zum Startpunkt
              (itoa (fix (+ 0.5 (car spb))))
              ","
              (itoa (fix (+ 0.5 (nth 1 spb))))
              ",1,"))	;Feder runter
  (setq dx (- (fix (+ 0.5 (car epb)))	;end x relativ
              (fix (+ 0.5 (car spb)))))
  (setq dy (- (fix (+ 0.5 (nth 1 epb))) 	;end y relativ
              (fix (+ 0.5 (nth 1 spb)))))
  (setq temp (strcat temp "12,"	;Bogen
              (itoa dx) ","	;x-Verschiebung
              (itoa dy) ","	;y-Verschiebung
              (itoa abb)	;Ausbuchtung
              ",2,"	;Feder hoch
             )	;end strcat
  )	;end setq
  (setq dx (- 0 (fix (+ 0.5 (car epb)))))	;zum Anf. x relativ
  (setq dy (- 0 (fix (+ 0.5 (nth 1 epb))))) 	;zum Anf. y relativ
              
  (setq temp (strcat temp "8,"
              (itoa dx) ","	;x-Verschiebung
              (itoa dy) ","	;y-Verschiebung
             )	;end strcat
  )	;end setq
  (if (= pass 2)(write-line temp dch))	;nach dch
  (setq byts (+ byts 12))	;12 dazu                   
 
  (setq z (1+ z))	;inkr Zhler
 )	;end while


(setq temp (strcat "8,"
              (itoa (car xye)) ","	;x-Verschiebung
              (itoa (cdr xye)) ","	;y-Verschiebung
           )	;end strcat
)	;end setq
(if (= pass 2)(write-line temp dch))	;nach dch
(setq byts (+ byts 3))	;3 dazu                   

)	;end defun mabo


(defun mazu(pass / temp)	;mache letzte Zeile
(setq dx (/ (car xye) 2))	;-halbe Breite
(setq dy (- (cdr xyu) 6))	;-Hoehe
(setq temp (strcat "2,14,6,14,8," (itoa dx)	;Vertikalstil
              "," (itoa dy) ",0"))	;pop,dx,dy,0
(setq byts (+ byts 8))	;8 Bytes merken
(if (= pass 2)(write-line temp dch))	;nach dch
)	;Ende defun mazu


(defun rtest( / ri)	;Richtigtest
(setq ri 0)	;nichts richtig
(setq rflag nil)	;Richtigflag
(if (/= xye nil) (setq ri (1+ ri))	;richtig
  (princ "\nEndpunkt Block EPKT fehlt "))	;Fehler
(if (/= xyh nil) (setq ri (1+ ri))	;richtig
  (princ "\nHoehe Block HPKT fehlt "))	;Fehler
(if (/= xyu nil) (setq ri (1+ ri))	;richtig
  (princ "\nUnterlnge Block UPKT fehlt "))	;Fehler
(if (/= synum nil) (setq ri (1+ ri))	;richtig
  (princ "\nSymbol-/ASCII-Nummer fehlt "))	;Fehler
(if (/= dnam nil) (setq ri (1+ ri))	;richtig
  (princ "\nDateiname fehlt "))	;Fehler
(if boflag (setq  ri (1+ ri))	;richtig
  (princ "\nBogen grsser 180 Grad "))	;Fehler
(if (= ri 6) (setq rflag t))	;alles richtig
(if (not rflag)(princ "  *Abbruch*"))	;anzeigen
)	;Ende defun rtest

(defun dada()	;Datei vorhanden
(if (not (setq ch1 (open dnam "r")))	;wenn nicht da
  (progn	;beginn
  (setq a1 (getstring
  (strcat "Zeichensatzdatei " dnam " anlegen? n/<j>: ")))
    (if (or (= a1 "")(= a1 "j")(= a1 "J"))
    (mzdat)	;mach Zeichensatzdatei
    (setq rflag nil)	;Abbruch
    )
  )	;end progn
)	;end if
)	;end defun dada

(defun mzdat( / sn ol ul za)
(setq sn (getstring t "Bezeichnung des Zeichensatzes eingeben: "))
(setq ol (getint "Oberlnge als Ganzzahl eingeben <21>: "))
(if (not ol)(setq ol 21))	;wenn return
(setq ol (itoa ol))	;Zahl in String
(setq ul (getint "Unterlnge als Ganzzahl eingeben <7>: "))
(if (not ul)(setq ul 7))	;wenn return
(setq ul (itoa ul))	;Zahl in String
(setq za (getint "Zeilenabstand als Ganzzahl eingeben <18>: "))
(if (not za)(setq za 18))	;wenn return
(setq za (itoa za))	;Zahl in String
(setq ch1 (open dnam "w"))	;neue Datei


;(write-line (strcat "*0,4,Name " sn) ch1)	;Zeile Null
(write-line (strcat "*UNIFONT,6,Name " sn) ch1)	;Zeile Null

(write-line (strcat ol "," ul ",2,0,0,0") ch1)	;Zeile 1


(write-line "*0A,9,lf" ch1)	;lf
(write-line (strcat "2,8,0,-" za ",14,8,30," za ",0") ch1)	;lf
(close ch1)	;Datei zu
)

(defun dauf(pa)	;Datei ffnen
(setq dch (open dnam "a"))	;dnam write
(princ (strcat "Pass " (itoa pa) " -> "))	;Anzeigen
)	;Ende defun dauf


;------------P R O G R A M M S T A R T ---------
(varse)	;Variable setzen
(setq byts 0)	;Byteanzahl
(holasa)	;hole Auswahlsatz
(if (/= asa nil)	;wenn Elemente da
(progn	;Beginn
  (holspkt)	;hole Startpunkt
  (if (/= xys nil)	;Wenn Startpunkt
  (progn	;Beginn
  (holel)	;hole Elemente
  (rtest)	;Richtigtest
  (if rflag (dada))	;wenn ok Datei abfragen
  (if rflag	;wenn alles ok
    (progn	;Beginn ok
    (princ "Pass 1 -> ")	;Pass 1
    (maz1 1)	;mache Zeile 1
    (maz2 1)	;mache Zeile 2
    (maz3 1)	;mache Zeile 3
    (mazn 1)	;mache N Zeilen
    (if (> boanz 0)(mabo 1))	;mache Bgen
    (mazu 1)	;letzte Zeile
    (dauf 2)	;Pass 2
    (varse)	;set Variable
    (holspkt)	;hole Startpunkt
    (holel)	;hole Elemente
    (maz1 2)	;mache Zeile 1
    (maz2 2)	;mache Zeile 2
    (maz3 2)	;mache Zeile 3
    (mazn 2)	;mache N Zeilen
    (if (> boanz 0)(mabo 2))	;mache Bgen
    (mazu 2)	;letzte Zeile
    (close dch)	;Datei dnam zu
    (write-line (strcat (itoa (/ byts 2))	;Kontroll- 
    " Bytes in Datei " (strcase dnam)	;an-
    " geschrieben"))	;zeige
    ))	;end if rflag
 )
 (print "Abbruch, Startpunkt Block SPKT fehlt")	;if xys=0
 )	;end if xys#0
))	;if asa#nil
(res_sysvars)	;restore sysvars
(setq *error* *olderror*)	;restore Fehlerhandler
(princ)	;unterdr nil
) 	;EOF fonted03.lsp

(princ "\nProgrammstart mit fonted03")

