(defun c:fonttab()	
;schreibt Zeichen eines Zeichensatzes
;auf den Bildschirm
;Eingangsdatei ist UNIFONT-Datei: *.SHP
;
;(c) H.-P. Rust, 2003

(setq debug nil)	;zum debuggen T


(setq pnam "FONTTAB.LSP")	;Programmname
(setq pver " V 1.0")	;Programmversion
(setq cpry " (c) Rust 2003 ")




(setq *olderror* *error*)	;Fehlerhandler retten

(defun *error*(msg)	;Fehlerhandler
(if ch1 (close ch1))	;schliessen, falls offen
(setq debug nil)
(res_sysvars)	;restore sysvars
(setq *error* *olderror*)	;restore Fehlerhandler
(princ pnam)
(princ pver)
(princ cpry)
(princ))	;end defun *error*


(defun get_sysvars()	;Systemvariablen merken
(setq o_s (getvar "osmode"))	;Objektfang merken
(setq s_m (getvar "snapmode"))	;Fang merken
(setq a_p (getvar "aperture"))	;Aperture merken
(setq c_e (getvar "cmdecho"))	;Echo merken
(setq b_m (getvar "blipmode"))	;Blips merken
(setq p_w (getvar "plinewid"))	;Polylinienbreite
(setq c_c (getvar "cecolor"))	;Farbe
(setq c_l (getvar "celtype"))	;Linientyp
)	;end defun get_sysvars

(defun res_sysvars()	;restore sysvars
(setvar "osmode" o_s)	;Objektfang
(setvar "snapmode" s_m)	;Fang
(setvar "aperture" a_p)	;Aperture 
(setvar "cmdecho" c_e)	;Echo
(setvar "blipmode" b_m)	;Blips
(setvar "plinewid" p_w)	;Polylinienbreite
(setvar "cecolor" c_c)	;Farbe
(setvar "celtype" c_l)	;Linientyp
)	;end defun res_sysvars

(get_sysvars)	;Systemvariablen merken


(setvar "cmdecho" 0)	;Echo aus
(setvar "blipmode" 0)	;keine Blips
(setvar "osmode" 0)







(defun s4komma(z / z n nmax)	;search Komma
(setq nmax 7)	;max 7 characters
(setq n 1)
(while (< n nmax)
 (setq n (1+ n))
 (setq temp (substr z n 1))
(if debug 
(progn
(princ temp)
(princ " ")
)
)
 (if (= temp ",")
  (progn
  (setq nmax 0)	;Komma gefunden
 ))	;end progn if
)	;end while
n	;Wert zurck
)



(setvar "CMDECHO" 0)

(if (/= (type zdat) 'STR)
(setq zdat "romans")
)

(princ "SHP-Zeichensatzdatei eingeben <")
(princ zdat)
(setq temp (getstring ">: "))
(if (/= temp "")(setq zdat temp))	;nicht return



;start Hauptprogramm

(setq datnam (findfile (strcat zdat ".shp")))	;SHP-Datei suchen


(if (not datnam) (princ "\nDatei nicht gefunden, Abbruch..."))

(if datnam 	;Datei gefunden
(progn

(princ "\nAchtung, es wird ein Stil mit dem Namen TEMP angelegt")
(princ "\nWeiter mit RETURN, Abbruch mit ESC...")
(grread)
(command "-stil" "temp" zdat 25.0 0.8 0 "N" "N" "N")


(princ "Dateiname: ")(princ datnam)(princ "\n")

(if ch1 (close ch1))	;close, if any open
  
(setq ch1 (open datnam "r"))	;open for read

(setq unifont "")	;Unifont keyword suchen

(setq znr 0)	;Zeilennummer fr Schlsselword UNIFONT
(while (and (/= unifont "UNIFONT") (setq temp (read-line ch1)))
(setq znr (1+ znr))
(setq unifont (substr temp 2 7))
(setq zeile temp)
)	;end while

(if (/= unifont "UNIFONT")(print "Keine UNIFONT-Datei, Abbruch..."))	

(if (= unifont "UNIFONT")	;wenn unifont
(progn				;begin

(princ "\nIst Unifont-Datei: ")
(princ zeile)
(princ "\n")

(setq p1 (getpoint "Einfgepunkt eingeben: "))
(setq p0 p1)



(setq n 300000)
(setq spalte 0)
(setq zeile 0)

(while (and (> n 0) (setq z (read-line ch1)))	;until n or EOF
(if debug (print "while"))
(setq n (1- n))
(setq c1 (substr z 1 1))
(setq zanz (strlen z))  

(setq nc (ascii c1))	;stern ist 42

(if (= 42 nc)
(progn
(if debug (print z))
(setq nk (s4komma z))	;Komma suchen
(setq a 2)	;start with 2nd char
(setq charnr (substr z a (- nk a)))	;extract number
(setq charanz (strlen charnr))
(if debug (progn(princ "char lnge: ")(princ charanz)))
(if (= charanz 2)(setq bout (strcat "" charnr)))
(if (= charanz 3)(setq bout (strcat "\\u+0" charnr)))
(if (= charanz 4)(setq bout (strcat "\\u+" charnr)))
(if (= charanz 5)(setq bout (strcat "\\u+" (setq charnr (substr charnr 2)))))

(if debug (progn(princ "bout: ")(princ bout)))

(setq 2print (strcat charnr " " bout))
(command "TEXT" p1 "" 2print)

(setq p1 (polar p1 0 160))
(setq spalte (1+ spalte))
(if debug (print spalte))

(if (= spalte 16)
(progn
(setq p0 (polar p0 (/ pi 2) 60))
(setq p1 p0)
(setq spalte 0)
))	;end if progn

))	;end progn if



)	;end while readline



(close ch1)


))	;end end if wenn unifont


;(command "TEXT" p1  "" "x" "" "")

))	;if progn datnam


(command "ZOOM" "a")	;fr ZOOM Alles
(res_sysvars)	;restore sysvars
(setq *error* *olderror*)	;restore Fehlerhandler
(princ)
)	;end fonttab
(princ "\nFONTTAB geladen..., Start mit FONTTAB")(princ)